<?php
/**
 * RecommendationApi
 * PHP version 5
 *
 * @category Class
 * @package  Boxxai\Magic
 * @author   Boxx Codegen team
 * @link     https://github.com/Boxx-api/Boxx-codegen
 */

/**
 * Recommendation API 2
 *
 * No description provided (generated by Boxx Codegen https://github.com/Boxx-api/Boxx-codegen)
 *
 * OpenAPI spec version: 1.5.0
 *
 * Generated by: https://github.com/Boxx-api/Boxx-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the Boxx code generator program.
 * https://github.com/Boxx-api/Boxx-codegen
 * Do not edit the class manually.
 */

namespace Boxxai\Magic\Api;

use \Boxxai\Magic\ApiClient;
use \Boxxai\Magic\ApiException;
use \Boxxai\Magic\Configuration;
use \Boxxai\Magic\ObjectSerializer;

/**
 * RecommendationApi Class Doc Comment
 *
 * @category Class
 * @package  Boxxai\Magic
 * @author   Boxx Codegen team
 * @link     https://github.com/Boxx-api/Boxx-codegen
 */
class RecommendationApi
{
    /**
     * API Magic
     *
     * @var \Boxxai\Magic\ApiClient instance of the ApiClient
     */
    protected $ApiClient;

    /**
     * Constructor
     *
     * @param \Boxxai\Magic\ApiClient|null $ApiClient The api Magic to use
     */
    public function __construct(\Boxxai\Magic\ApiClient $ApiClient = null)
    {
        if ($ApiClient === null) {
            $ApiClient = new ApiClient();
        }

        $this->ApiClient = $ApiClient;
    }

    /**
     * Get API Magic
     *
     * @return \Boxxai\Magic\ApiClient get the API Magic
     */
    public function getApiClient()
    {
        return $this->ApiClient;
    }

    /**
     * Set the API Magic
     *
     * @param \Boxxai\Magic\ApiClient $ApiClient set the API Magic
     *
     * @return RecommendationApi
     */
    public function setApiClient(\Boxxai\Magic\ApiClient $ApiClient)
    {
        $this->ApiClient = $ApiClient;
        return $this;
    }

    /**
     * Operation rootPost
     *
     * @param \Boxxai\Magic\Model\RecommendationRequestData $request_data request data (required)
     * @throws \Boxxai\Magic\ApiException on non-2xx response
     * @return \Boxxai\Magic\Model\InlineResponse200
     */
    public function rootPost($request_data)
    {
        list($response) = $this->rootPostWithHttpInfo($request_data);
        return $response;
    }

    /**
     * Operation rootPostWithHttpInfo
     *
     * @param \Boxxai\Magic\Model\RecommendationRequestData $request_data request data (required)
     * @throws \Boxxai\Magic\ApiException on non-2xx response
     * @return array of \Boxxai\Magic\Model\InlineResponse200, HTTP status code, HTTP response headers (array of strings)
     */
    public function rootPostWithHttpInfo($request_data)
    {
        // verify the required parameter 'request_data' is set
        if ($request_data === null) {
            throw new \InvalidArgumentException('Missing the required parameter $request_data when calling rootPost');
        }
        // parse inputs
        $resourcePath = "/";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->ApiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->ApiClient->selectHeaderContentType(['application/json']);

        // body params
        $_tempBody = null;
        if (isset($request_data)) {
            $_tempBody = $request_data;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->ApiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\Boxxai\Magic\Model\InlineResponse200',
                '/'
            );

            return [$this->ApiClient->getSerializer()->deserialize($response, '\Boxxai\Magic\Model\InlineResponse200', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->ApiClient->getSerializer()->deserialize($e->getResponseBody(), '\Boxxai\Magic\Model\InlineResponse200', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = $this->ApiClient->getSerializer()->deserialize($e->getResponseBody(), '\Boxxai\Magic\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 401:
                    $data = $this->ApiClient->getSerializer()->deserialize($e->getResponseBody(), '\Boxxai\Magic\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 405:
                    $data = $this->ApiClient->getSerializer()->deserialize($e->getResponseBody(), '\Boxxai\Magic\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }
}
